// program.cpp
// Copyright (C) 2007-2009 Andrew Munkres
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

#include <kstandardaction.h>
#include <ktoggleaction.h>
#include <klocale.h>
#include <kservicetypetrader.h>
#include <kmimetypetrader.h>
#include <kparts/componentfactory.h>
// #include <kuserprofile.h>
#include <kurl.h>
#include <kstandarddirs.h>
#include <kmenu.h>
#include <kdebug.h>
#include <kactioncollection.h>
#include <kxmlguifactory.h>
#include <QString>
#include <QBuffer>
#include <QLayout>
#include <QHeaderView>
#include <QTimer>
#include <QCloseEvent>
#include "program.h"
#include "leftpane.h"
#include "toppane.h"
#include "readbuffer.h"

#include "koeurlconfig.h" // Autogenerated by kconfig_compiler

#include "program.moc" // This must be here for moc to be run.

ProgramWindow::ProgramWindow(): KXmlGuiWindow(), m_bp(0), m_outbuf(0),
  m_active_repo(0), m_ready_to_close(false), m_status_bar(statusBar()),
  m_progress_bar(new QProgressBar())
{
  // create actions
  KToggleAction *
    lp_a(actionCollection()->add<KToggleAction>("toggle_leftpane"));
  lp_a->setText(i18n("&Hide Left Pane"));
  lp_a->setIcon(KIcon("view-sidetree"));
  KStandardAction::quit(this, SLOT(beginShutdown()), actionCollection());
  m_del =
    actionCollection()->addAction("del_repo", this, SLOT(deleteChosenRepo()));
  m_del->setText(i18n("&Delete Message Repository"));
  createGUI();
  
  // load repository type plugins
  KService::List
    offers(KServiceTypeTrader::self()->query("MsgRepo/Type"));
  KService::List::ConstIterator iter;
  // int errCode = 0;
  QString error_text;
  MsgRepoType *type;
  for (iter = offers.begin(); iter != offers.end(); ++iter)
  {
    QVariantList args;
    args << (*iter)->name() << (*iter)->library();
    type = (*iter)->createInstance<MsgRepoType>(this, args, &error_text);
    if (type)
    {
      guiFactory()->addClient(type);
      m_repotypes.insert((*iter)->library(), type);
      kDebug() << i18n("Program has loaded plugin %1 %2")
                    .arg((*iter)->name(), (*iter)->library());
    }
    else
    {
      kDebug() << i18n("Program failed to load plugin %1 for reason: %2")
                    .arg((*iter)->name(), error_text);
    }
  }
  
  // create layout of window
  m_hsplit = new QSplitter(this);
  m_lp = new LeftPane(m_hsplit);
  connect(lp_a, SIGNAL(toggled(bool)), m_lp, SLOT(toggleShown(bool)));
  m_vsplit = new QSplitter(Qt::Vertical, m_hsplit);
  m_tp = new TopPane(m_vsplit);
  m_holder = new QFrame(m_vsplit);
  new QHBoxLayout(m_holder);
  /* There doesn't seem to be a direct equivalent to this in Qt 4:
  m_hsplit->setResizeMode(m_lp, QSplitter::FollowSizeHint);
  m_vsplit->setResizeMode(m_tp, QSplitter::FollowSizeHint);
  */
  QString state(Settings::horizontalSplitterState());
  if (!state.isEmpty())
    m_hsplit->restoreState(QByteArray::fromBase64(state.toLocal8Bit()));
  state = Settings::verticalSplitterState();
  if (!state.isEmpty())
    m_vsplit->restoreState(QByteArray::fromBase64(state.toLocal8Bit()));
  connect(m_hsplit, SIGNAL(splitterMoved(int, int)),
          this, SLOT(horizontalSplitterMoved(int, int)));
  connect(m_vsplit, SIGNAL(splitterMoved(int, int)),
          this, SLOT(verticalSplitterMoved(int, int)));
  
  setCentralWidget(m_hsplit);
  
  // enable auto-save (this will save window size, among other things)
  setAutoSaveSettings();
  
  // restore miscellaneous settings
  if (!Settings::leftPaneShown())
  {
    lp_a->setChecked(true);
    m_lp->hide();
  }
  
  // read the repository configuration file
  m_inbuf = new ReadBuffer();
  kDebug() << "Folders file path is:" << KStandardDirs::locateLocal("appdata", "folders.koeurl") << endl;
  KIO::TransferJob *j =
    KIO::get(KUrl(KStandardDirs::locateLocal("appdata", "folders.koeurl")),
             KIO::NoReload, KIO::HideProgressInfo);
  connect(j, SIGNAL(data(KIO::Job *, const QByteArray &)),
          m_inbuf, SLOT(appendData(KIO::Job *, const QByteArray &)));
  connect(j, SIGNAL(result(KJob *)),
          this, SLOT(finishedReading(KJob *)));
  // note: no need to explicitly disconnect these signals, since they will
  // be disconnected when the job object is deleted, which happens
  // automatically
  
  m_progress_bar->setMaximumHeight(fontMetrics().height());
  m_progress_bar
    ->setMaximumWidth(fontMetrics().width("width of progress bar"));
  m_status_bar->addPermanentWidget(m_progress_bar);
  m_progress_bar->hide();
  // m_status_bar->showMessage(i18n("Test status message"));
}

ProgramWindow::~ProgramWindow()
{
  // saveRepoLayout();
}

void ProgramWindow::horizontalSplitterMoved(int, int)
{
  Settings::setHorizontalSplitterState(m_hsplit->saveState().toBase64());
  Settings::self()->writeConfig();
}

void ProgramWindow::verticalSplitterMoved(int, int)
{
  Settings::setVerticalSplitterState(m_vsplit->saveState().toBase64());
  Settings::self()->writeConfig();
}

void ProgramWindow::beginShutdown()
{
  kDebug() << "In beginShutdown()" << endl;
  saveRepoLayout(SLOT(quitProgram(KJob *)), SLOT(quitProgram()));
}

void ProgramWindow::quitProgram(KJob *)
{
  kDebug() << "In quitProgram(KJob *)" << endl;
  m_ready_to_close = true;
  static_cast<QWidget *>(this)->close();
}

void ProgramWindow::quitProgram()
{
  quitProgram(0);
}

void ProgramWindow::closeEvent(QCloseEvent *event)
{
  if (m_ready_to_close)
    event->accept();
  else
  {
    event->ignore();
    beginShutdown();
  }
}

void ProgramWindow::finishedReading(KJob *done_j)
{
  if (done_j->error())
  {
    // assume file doesn't exist; create empty configuration
    // TODO: handle errors other than file doesn't exist
    QDomImplementation impl;
    m_folders =
      impl.createDocument(QString::null, "folders",
        impl.createDocumentType("folderlist", QString::null,
                                QString::null));
  }
  else
  {
    m_folders.setContent(m_inbuf->m_qbuf->buffer());
  }
  delete m_inbuf;
  QDomNodeList repos(m_folders.documentElement().childNodes());
  MsgRepoTypeMap::iterator type_ref;
  MsgRepo *repo;
  uint count(repos.length()), i(0);
  for (; i < count; ++i)
  {
    QDomElement saved_config(repos.item(i).toElement());
    type_ref = m_repotypes.find(saved_config.attribute("type"));
    if (m_repotypes.end() != type_ref)
    {
      repo = (*type_ref)->createRepo(saved_config);
      new MsgRepoItem(m_lp, saved_config, repo, m_tp);
    }
  }
}

void ProgramWindow::foldersText(KIO::Job *, QByteArray &data)
{
  if (m_outbuf)
  {
    m_outbuf->chop(1); // remove trailing \0
    data = *m_outbuf;
    delete m_outbuf;
    m_outbuf = 0;
  }
}

KDE_EXPORT void ProgramWindow::insertRepo(MsgRepo *repo)
{
  if (m_active_repo)
  {
    new MsgRepoItem(m_lp, m_active_repo, repo, m_tp);
  }
  else
  {
    new MsgRepoItem(m_lp, m_folders, repo, m_tp);
  }
  rewriteFolders();
}

void ProgramWindow::showRepoMenu(QTreeWidgetItem *item, const QPoint &p)
{
  m_del->setEnabled(0 != item); // disable iff no item is selected
  // NOTE: I think this is redundant:
  // m_active_repo = static_cast<MsgRepoItem *>(item);
  (static_cast<KMenu *>(factory()->container("context_leftpane",
                                             this)))->popup(p);
}

void ProgramWindow::deleteChosenRepo()
{
  kDebug() << i18n("Deleting repo %1").arg(m_active_repo->text(0)) << endl;
  MsgRepoItem *repo(static_cast<MsgRepoItem *>(
                      m_lp->selectedItems().first()));
  if (m_active_repo == repo)
    m_active_repo = 0;
  delete repo;
  rewriteFolders();
}

void ProgramWindow::rewriteFolders(const char *onFinishWrite)
{
  m_outbuf = new QByteArray(m_folders.toByteArray(2));
  KIO::TransferJob
    *j(KIO::put(KUrl(KStandardDirs::locateLocal("appdata", "folders.koeurl")),
                -1, KIO::Overwrite | KIO::HideProgressInfo));
  connect(j, SIGNAL(dataReq(KIO::Job *, QByteArray &)),
          this, SLOT(foldersText(KIO::Job *, QByteArray &)));
  if (onFinishWrite)
    connect(j, SIGNAL(result(KJob *)), this, onFinishWrite);
  // note: no need to explicitly disconnect these signals, since they will be
  // disconnected when the job object is deleted, which happens automatically
}

void ProgramWindow::selectRepo(QTreeWidgetItem *repo_item)
{
  // Save list view settings for previously-selected repo
  saveRepoLayout();
  
  MsgRepo *repo;
  if (m_active_repo)
  {
    repo = m_active_repo->getRepoOfItem();
    disconnect(repo, SIGNAL(statusMessage(const QString &, int)),
               m_status_bar, SLOT(showMessage(const QString &, int)));
    disconnect(repo, SIGNAL(progressRange(int, int)),
               m_progress_bar, SLOT(setRange(int, int)));
    disconnect(repo, SIGNAL(progressValue(int)),
               m_progress_bar, SLOT(setValue(int)));
    disconnect(repo, SIGNAL(progressVisible(bool)),
               m_progress_bar, SLOT(setVisible(bool)));
  }
  
  // Get the per-repository actions menu, clear it, then hand it to the newly-
  // selected repo if there is one.
  KMenu *menu(
    static_cast<KMenu *>(factory()->container("repo_actions", this)));
  menu->clear();
  
  m_active_repo = static_cast<MsgRepoItem *>(repo_item);
  if (m_active_repo) // NOTE: do we need to check for 0 here?
  {
    repo = m_active_repo->getRepoOfItem();
    connect(repo, SIGNAL(statusMessage(const QString &, int)),
            m_status_bar, SLOT(showMessage(const QString &, int)));
    connect(repo, SIGNAL(progressRange(int, int)),
            m_progress_bar, SLOT(setRange(int, int)));
    connect(repo, SIGNAL(progressValue(int)),
            m_progress_bar, SLOT(setValue(int)));
    connect(repo, SIGNAL(progressVisible(bool)),
            m_progress_bar, SLOT(setVisible(bool)));
    
    m_active_repo->prepareToShow(menu, actionCollection());
  }
}

void ProgramWindow::saveRepoLayout(const char *onFinishWrite, const char *onFinishNoWrite)
{
  if (m_active_repo)
  {
    // m_tp->saveLayout(Settings::self()->config(),
    //                  m_active_repo->getRepoOfItem()->name() +
    //                  " List View Settings");

    kDebug() << i18n("Saving header state of repo %1").arg(m_active_repo->text(0)) << endl;
    // NOTE: These settings are stored per-repository
    
    m_active_repo->
      m_config.setAttribute(QString("ui_state"),
                            QString(m_tp->header()->saveState().toBase64()));
    rewriteFolders(onFinishWrite);
  }
  else if (onFinishNoWrite)
  {
    QTimer::singleShot(0, this, onFinishNoWrite);
  }
}

void ProgramWindow::selectMessage(QTreeWidgetItem *msg_item)
{
  if (msg_item)
    m_active_repo->prepareToShowMessage(static_cast<SummaryItem *>(msg_item));
}

void ProgramWindow::showMessage()
{
  // TODO: remove the previous message from the display, and deallocate it
  
  m_displayed_message = m_active_repo->getRepoOfItem()->getSelectedMessage();
  KMenu *menu = static_cast<KMenu *>
                  (factory()->container("message", this));
  menu->clear();
  m_displayed_message->buildPartsMenu(menu, actionCollection());
  
  // Display the default message "part"
  showMessagePart();
}

void ProgramWindow::showMessagePart()
{
  // Find the KPart for the MIME type of the currently-selected message part.
  KService::Ptr service(KMimeTypeTrader::self()->preferredService(
                          m_displayed_message->getMIMEType(),
                          "KParts/ReadOnlyPart"));
  KParts::ReadOnlyPart *viewer(0);
  
  // Instantiate the found KPart.
  if (service)
  {
    viewer = service->createInstance<KParts::ReadOnlyPart>(m_holder, 0);
    // TODO: maybe later have it return the error status (a
    // KParts::ComponentFactory::ComponentLoadingError)
  }
  
  // Remove the KPart for the previously-viewed message (if any) and replace
  // it with the new one.
  if (viewer)
  {
    if (m_bp)
    {
      m_holder->layout()->removeWidget(m_bp);
      delete m_bp_part;
    }
    m_bp_part = viewer;
    m_bp = viewer->widget();
    m_holder->layout()->addWidget(m_bp);
    
    // Hand the KPart to the Message object so it can send the data of the
    // message part to the KPart.
    m_displayed_message->beginLoadingPartData(viewer);
  }
  // TODO: add some real error handling here
}
